import time
from datetime import datetime
from dateutil.relativedelta import relativedelta

from openerp.osv import fields, osv
import openerp.addons.decimal_precision as dp

from lxml import etree
import netsvc
from osv import osv, fields
import decimal_precision as dp
from tools.translate import _

class l10n_tn_immo(osv.osv):
    

    _inherit = "account.asset.asset" 
    	
    def _check_dates(self, cr, uid, ids, context=None):
       
       for payslip in self.browse (cr, uid, ids, context=context):
          if payslip.date_cession < payslip.date_service:
	        return False
       return True		

    _constraints = [(_check_dates, "'date de Cession' doit etre apres 'date de mise en service'.", ['date_cession', 'date_service'])]		

    
    
	
    _columns = {
    'type': fields.selection([('corporelle','Corporelle'),('incorporelle','Incorporelle')],'Type immobilisation'),
	'code_barre':fields.char('Code a barre EAN13',size= 32),
	'affectation':fields.many2one('hr.department', 'Affectation'),
	'date_service':fields.date('Date de mise en service', required=True, readonly=True, states={'draft':[('readonly',False)]}),
	'facture_cession':fields.char('Num Facture de vente',size= 32),
	'type_cession': fields.selection([('vente','Vente'),('rebut','Rebut'),('don','Don'),('mise','Mise en service')],'Type de Cession'),
	'date_cession':fields.date('Date de Cession', required=True, readonly=True, states={'draft':[('readonly',False)]}, help="Date de Cession"),
	'valeur_cession':fields.integer('Valeur de Cession',size= 32),
	'acheteur':fields.many2one('res.partner', 'Acheteur'),
	'amortir' : fields.boolean('Amortir annee de Cession'),
	#'ff': fields.function(_check_dates, method=True, type='boolean', store=True),
		}
		
l10n_tn_immo()

class account_inventory(osv.osv):
    _name = "account.inventory"
    _description = "Inventory"
    _columns = {
        'name': fields.char('Reference', size=64, required=True, readonly=True, states={'draft': [('readonly', False)]}),
        'date': fields.datetime('Date de creation', required=True, readonly=True, states={'draft': [('readonly', False)]}),
        'date_done': fields.datetime('Date done'),
		'inventory_line_id': fields.one2many('account.inventory.line', 'inventory_id', 'Inventaires', readonly=True, states={'draft': [('readonly', False)]}),
		'move_ids': fields.many2many('account.asset.asset', 'inventory_id', 'move_id', 'immobilisation'),
        'state': fields.selection( (('draft', 'Draft'), ('cancel','Cancelled'), ('confirm','Confirmed'), ('done', 'Done')), 'Status', readonly=True, select=True),
        'company_id': fields.many2one('res.company', 'Company', required=True, select=True, readonly=True, states={'draft':[('readonly',False)]}),
		#'product_uom': fields.many2one('product.uom', ' Unite de mesure', required=True),
		'product_id': fields.many2one('account.asset.asset', 'Produit', required=True, select=True),
		'product_qty': fields.float('Quantite', digits_compute=dp.get_precision('Product Unit of Measure')),
    }
    _defaults = {
        'date': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
        'state': 'draft',
        'company_id': lambda self,cr,uid,c: self.pool.get('res.company')._company_default_get(cr, uid, 'account.inventory', context=c)
    }
    def copy(self, cr, uid, id, default=None, context=None):
        if default is None:
            default = {}
        default = default.copy()
        default.update({'move_ids': [], 'date_done': False})
        return super(account_inventory, self).copy(cr, uid, id, default, context=context)
    
	
		
    def action_done(self, cr, uid, ids, context=None):
        
        if context is None:
            context = {}
        move_obj = self.pool.get('account.asset.asset')
        for inv in self.browse(cr, uid, ids, context=context):
            move_obj.action_done(cr, uid, [x.id for x in inv.move_ids], context=context)
            self.write(cr, uid, [inv.id], {'state':'done', 'date_done': time.strftime('%Y-%m-%d %H:%M:%S')}, context=context)
        return True	

account_inventory()
class account_inventory_line(osv.osv):
    _name = "account.inventory.line"
    _description = "Inventory Line"
    _rec_name = "inventory_id"
    _columns = {
        'inventory_id': fields.many2one('account.inventory', 'Inventaire', ondelete='cascade', select=True),
        #'location_id': fields.many2one('hr.department', 'Location', required=True),
        'product_id': fields.many2one('account.asset.asset', 'Produit', required=True, select=True),
        #'product_uom': fields.many2one('product.uom', ' Unite de mesure', required=True),
        'product_qty': fields.float('Quantite', digits_compute=dp.get_precision('Product Unit of Measure')),
        'company_id': fields.related('inventory_id','company_id',type='many2one',relation='res.company',string='Company',store=True, select=True, readonly=True),
        'prod_lot_id': fields.many2one('stock.production.lot', 'Serial Number', domain="[('product_id','=',product_id)]"),
        'state': fields.related('inventory_id','state',type='char',string='Status',readonly=True),
       
    }  

account_inventory_line()









